UI libraries / Angular InstantSearch / Widgets
Signature
<ais-toggle
  [attribute]="string"
  [label]="string"

  // Optional parameters
  [on]="boolean|number|string"
  [off]="boolean|number|string"
></ais-toggle>
Import
1
2
3
4
5
6
7
8
import { NgAisToggleModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisToggleModule,
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-toggle widget provides an on / off filtering feature based on an attribute value.

Examples

1
2
3
4
<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
></ais-toggle>

Props

attribute
type: string
Required

The name of the attribute on which to apply the refinement.

To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.

1
2
3
4
<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
></ais-toggle>
label
type: string
Required

Label to display for the checkbox.

1
2
3
4
<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
></ais-toggle>
on
type: boolean|number|string
default: true
Optional

The value of the refinement to apply on the attribute when checked.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
  on="yes"
></ais-toggle>

<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
  [on]="true"
></ais-toggle>

<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
  [on]="1"
></ais-toggle>
off
type: boolean|number|string
Optional

The value of the refinement to apply on the attribute when unchecked.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
  off="no"
></ais-toggle>

<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
  [off]="false"
></ais-toggle>

<ais-toggle
  attribute="free_shipping"
  label="Free Shipping"
  [off]="0"
></ais-toggle>

HTML output

1
2
3
4
5
6
7
<div class="ais-ToggleRefinement">
  <label class="ais-ToggleRefinement-label">
    <input class="ais-ToggleRefinement-checkbox" type="checkbox" />
    <span class="ais-ToggleRefinement-labelText">Free Shipping</span>
    <span class="ais-ToggleRefinement-count">18,013</span>
  </label>
</div>

Customize the UI with connectToggleRefinement

If you want to create your own UI of the ais-toggle widget, you can combine the connectToggleRefinement connector with the TypedBaseWidget class.

1. Extend the TypedBaseWidget class

First of all, you will need to write some boilerplate code to initialize correctly the TypedBaseWidget class. This happens in the constructor() of your class extending the TypedBaseWidget class.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

@Component({
  selector: 'app-toggle-refinement',
  template: '<p>It works!</p>'
})
export class ToggleRefinement extends TypedBaseWidget {
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('ToggleRefinement');
  }
}

There are a couple of things happening in this boilerplate:

  • create a ToggleRefinement class extending TypedBaseWidget
  • reference the <ais-instantsearch> parent component instance on the ToggleRefinement widget class
  • set app-toggle-refinement as a selector, so we can use our component as <app-toggle-refinement></app-toggle-refinement>

2. Connect your custom widget

The TypedBaseWidget class has a method called createWidget() which takes two arguments: the connector to use and an object of options (instance options) for this connector. We call this method at ngOnInit. This component now implements OnInit.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectToggleRefinement, {
  ToggleRefinementWidgetDescription,
  ToggleRefinementConnectorParams
} from 'instantsearch.js/es/connectors/toggle-refinement/connectToggleRefinement';

@Component({
  selector: 'app-toggle-refinement',
  template: '<p>It works!</p>'
})
export class ToggleRefinement extends TypedBaseWidget<ToggleRefinementWidgetDescription, ToggleRefinementConnectorParams> {
  public state: ToggleRefinementWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('ToggleRefinement');
  }
  ngOnInit() {
    this.createWidget(connectToggleRefinement, {
      // instance options
      attribute: 'free_shipping',
    });
    super.ngOnInit();
  }
}

3. Render from the state

Your component instance has access to a this.state property which holds the rendering options of the widget.

public state: ToggleRefinementWidgetDescription['renderState'];
// {
//   value: object;
//   refine: Function;
//   createURL: Function;
//   widgetParams: object;
// }
1
2
3
4
<label *ngIf="state.value">
  <input type="checkbox" [checked]="state.value.isRefined" (click)="state.refine(state.value)"/>
  Free shipping {{ state.value.count }}
</label>

Rendering options

value
type: object

The current refinement, with:

  • isRefined: boolean: whether the checkbox is checked.
  • count: number: the number of results after the refinement was applied.
  • onFacetValue: object: the value for the attribute. It contains count (useful to get the raw value of the count).
  • offFacetValue: object: the value for the attribute. It contains count (useful to get the raw value of the count).
refine
type: function

Updates to the next state by applying the toggle refinement.

createURL
type: function

Generates a URL for the next state.

widgetParams
type: object

All original widget options forwarded to the render function.

Instance options

attribute
type: string
Required

The name of the attribute on which to apply the refinement.

To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.

on
type: boolean|number|string
default: true
Optional

The value of the refinement to apply on the attribute when checked.

off
type: boolean|number|string
Optional

The value of the refinement to apply on the attribute when unchecked.

Full example

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
import { Component, Inject, forwardRef, Optional } from '@angular/core';
import { TypedBaseWidget, NgAisInstantSearch, NgAisIndex } from 'angular-instantsearch';

import connectToggleRefinement, {
  ToggleRefinementWidgetDescription,
  ToggleRefinementConnectorParams
} from 'instantsearch.js/es/connectors/toggle-refinement/connectToggleRefinement';

@Component({
  selector: 'app-toggle-refinement',
  template: `
<label *ngIf="state.value">
  <input type="checkbox" [checked]="state.value.isRefined" (click)="state.refine(state.value)"/>
  Free shipping {{ state.value.count }}
</label>
`
})
export class ToggleRefinement extends TypedBaseWidget<ToggleRefinementWidgetDescription, ToggleRefinementConnectorParams> {
  public state: ToggleRefinementWidgetDescription['renderState']; // Rendering options
  constructor(
    @Inject(forwardRef(() => NgAisIndex))
    @Optional()
    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('ToggleRefinement');
  }
  ngOnInit() {
    this.createWidget(connectToggleRefinement, {
      // instance options
      attribute: 'free_shipping',
    });
    super.ngOnInit();
  }
}
Did you find this page helpful?

Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
Signature
<ToggleRefinement
  attribute={string}
  // Optional parameters
  label={string}
  on={boolean | number | string}
  off={boolean | number | string}
  classNames={object}
  ...props={ComponentProps<'div'>}
/>

Import

JavaScript
import { ToggleRefinement } from "react-instantsearch";

See this widget in action

Preview this widget and its behavior.

About this widget

<ToggleRefinement> is a widget that provides an on/off filter based on an attribute value. For example, you can use this widget to only display products that apply for free shipping, or recipes that are gluten-free.
You can also create your own UI with useToggleRefinement.

Requirements

Make sure to declare the provided attribute as an attribute for faceting.

Examples

JavaScript
import React from "react";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import { InstantSearch, ToggleRefinement } from "react-instantsearch";

const searchClient = algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey");

function App() {
  return (
    <InstantSearch indexName="instant_search" searchClient={searchClient}>
      <ToggleRefinement attribute="free_shipping" />
    </InstantSearch>
  );
}

Props

attribute
string
required
The name of the attribute in the .To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.
JavaScript
<ToggleRefinement attribute="free_shipping" />;
label
string
The label to display for the checkbox.
JavaScript
<ToggleRefinement
  // ...
  label="Free shipping"
/>;
on
boolean | string | number
The value of the refinement to apply on the attribute when checked.
<ToggleRefinement
  // ...
  on={true}
/>;
off
boolean | string | number
The value of the refinement to apply on the attribute when unchecked.
<ToggleRefinement
  // ...
  off={false}
/>;
classNames
Partial<ToggleRefinementClassNames>
The CSS classes you can override and pass to the widget’s elements. It’s useful to style widgets with class-based CSS frameworks like Bootstrap or Tailwind CSS.
  • root. The root element of the widget.
  • label. The label element.
  • checkbox. The checkbox element.
  • labelText. The text element of the label.
JavaScript
<ToggleRefinement
  // ...
  classNames={{
    root: "MyCustomToggleRefinement",
    checkbox:
      "MyCustomToggleRefinementCheckbox MyCustomToggleRefinementCheckbox--subclass",
  }}
/>;
...props
React.ComponentProps<'div'>
Any <div> prop to forward to the root element of the widget.
JavaScript
<ToggleRefinement
  // ...
  className="MyCustomToggleRefinement"
  title="My custom title"
/>;

Hook

React InstantSearch let you create your own UI for the <ToggleRefinement> widget with useToggleRefinement. Hooks provide APIs to access the widget state and interact with InstantSearch. The useToggleRefinement Hook accepts parameters and returns APIs. It must be used inside the <InstantSearch> component.

Usage

First, create your React component:
JavaScript
import { useToggleRefinement } from "react-instantsearch";

function CustomToggleRefinement(props) {
  const { value, canRefine, refine, sendEvent, createURL } =
    useToggleRefinement(props);

  return <>{/* Your JSX */}</>;
}
Then, render the widget:
JavaScript
<CustomToggleRefinement {...props} />

Parameters

Hooks accept parameters. You can either pass them manually or forward props from a custom component.
When passing functions to Hooks, ensure stable references to prevent unnecessary re-renders. Use useCallback() for memoization. Arrays and objects are automatically memoized.
attribute
string
required
The name of the attribute in the records.To avoid unexpected behavior, you can’t use the same attribute prop in a different type of widget.
JavaScript
const toggleRefinementApi = useToggleRefinement({
  attribute: "free_shipping",
});
on
boolean | string | number
The value of the refinement to apply on the attribute when checked.
const toggleRefinementApi = useToggleRefinement({
  // ...
  on: true,
});
off
boolean | string | number
The value of the refinement to apply on the attribute when unchecked.
const toggleRefinementApi = useToggleRefinement({
  // ...
  off: false,
});

APIs

Hooks return APIs, such as state and functions. You can use them to build your UI and interact with React InstantSearch.
value
ToggleRefinementValue
The current refinement.
TypeScript
type ToggleRefinementValue = {
  /**
   * The attribute name of this toggle.
   */
  name: string;
  /**
   * Whether the current option is "on" (true) or "off" (false)
   */
  isRefined: boolean;
  /**
   * Number of results if this option is toggled.
   */
  count: number | null;
  /**
   * Information about the "on" toggle.
   */
  onFacetValue: ToggleRefinementDetails;
  /**
   * Information about the "off" toggle.
   */
  offFacetValue: ToggleRefinementDetails;
};

type ToggleRefinementDetails = {
  /**
   * whether this option is enabled.
   */
  isRefined: boolean;
  /**
   * Number of result if this option is toggled.
   */
  count: number | null;
};
canRefine
boolean
Whether the search state can be refined.
JavaScript
const { canRefine } = useToggleRefinement({ attribute: "free_shipping" });

return <input disabled={!canRefine} type="checkbox" />;
refine
({ isRefined: boolean }) => void
Updates to the next state by applying the toggle refinement.
JavaScript
const { refine } = useToggleRefinement({ attribute: "free_shipping" });

return (
  <input
    onChange={(event) => refine({ isRefined: !event.target.checked })}
    type="checkbox"
  />
);
sendEvent
(eventType: string, facetValue: string, eventName?: string) => void
A function to send click events. The click event is automatically sent when calling refine. To learn more, see the insights middleware.
JavaScript
sendEvent("click", true);

// This sends a similar payload to the `insights` middleware.
// {
// eventType: 'click',
// insightsMethod: 'clickedFilters',
// payload: {
// eventName: 'Filter Applied',
// filters: ['free_shipping:true'],
// index: '',
// },
// widgetType: 'ais.toggleRefinement',
// }
createURL
() => string
Generates a URL for the next state.
JavaScript
const { createURL, value, refine } = useToggleRefinement({
  attribute: "free_shipping",
});

return (
  <a
    href={createURL()}
    onClick={(event) => refine({ isRefined: !value.isRefined })}
  >
    Link to the next state
  </a>
);

Example

import React from "react";
import { useToggleRefinement } from "react-instantsearch";

function CustomToggleRefinement(props) {
  const { value, refine } = useToggleRefinement(props);

  return (
    <label>
      <input
        type="checkbox"
        checked={value.isRefined}
        onChange={(event) => {
          refine({ isRefined: !event.target.checked });
        }}
      />

      <span>{props.attribute}</span>
    </label>
  );
}
Last modified on May 7, 2026